<script>
  import RouterView from './RouterView'
  import Groups from './routes/Groups'
  import GroupForm from './routes/GroupForm'
  import GroupView from './routes/Group'
  import HomeworkForm from './routes/HomeworkForm'
  import HomeworkResourcesView from './routes/HomeworkResources'
  import JoinGroup from './routes/JoinGroup'
  import InviteToGroup from './routes/InviteToGroup'
  import NotFound from './routes/NotFound'

  import ToastView from './components/ToastView'
  import LoadingBox from './components/LoadingBox'

  import {
    ArrowBack,
    HomeOutline,
    MoreVertical,
    ExternalLink,
  } from './assets/icons'

  import { writable } from 'svelte/store'
  import { onMount } from 'svelte'

  import router from './router'

  import offline from './stores/offline'
  import { setupStore as setupGroupsStore } from './stores/groups'
  import { setupStore as setupHomeworksStore } from './stores/homeworks'
  import { setupStore as setupHomeworkResourcesStore } from './stores/homeworkResources'
  import updateAvailable from './stores/updateAvailable'
  import { setToast } from './stores/toast'

  import { ensureOffline } from './utils/offlineUtils'

  const routes = [
    { regExp: /^\/$/, redirect: '/groups' },
    { regExp: /^\/groups$/, component: Groups, title: 'Grupos' },
    {
      regExp: /^\/groups\/create$/,
      component: GroupForm,
      title: 'Crear grupo',
      backCb: route => (location.hash = '#/groups'),
    },
    {
      regExp: /^\/groups\/([0-9]+)\/edit$/,
      component: GroupForm,
      title: 'Editar grupo',
      backCb: route => (location.hash = `#/groups/${route.matches[1]}`),
    },
    {
      regExp: /^\/groups\/([0-9]+)$/,
      component: GroupView,
      title: 'Grupo',
      backCb: route => (location.hash = '#/groups'),
    },
    {
      regExp: /^\/groups\/([0-9]+)\/homeworks\/create$/,
      component: HomeworkForm,
      title: 'Crear tarea',
      backCb: route => (location.hash = `#/groups/${route.matches[1]}`),
    },
    {
      regExp: /^\/groups\/([0-9]+)\/homeworks\/([0-9]+)\/edit$/,
      component: HomeworkForm,
      title: 'Editar tarea',
      backCb: route => (location.hash = `#/groups/${route.matches[1]}`),
    },
    {
      regExp: /^\/groups\/([0-9]+)\/homeworks\/([0-9]+)\/resources(#([0-9]+))?$/,
      component: HomeworkResourcesView,
      title: 'Recursos de la tarea',
      backCb: route => (location.hash = `#/groups/${route.matches[1]}`),
    },
    {
      regExp: /^\/groups\/([0-9]+)\/invite$/,
      component: InviteToGroup,
      title: 'Invitar a un grupo',
      backCb: route => (location.hash = `#/groups/${route.matches[1]}`),
    },
    {
      regExp: /^\/join\/([0-9]+),(.+)$/,
      component: JoinGroup,
      title: 'Unirse a un grupo',
      backCb: route => (location.hash = '#/groups'),
    },
    {
      regExp: /.+/,
      component: NotFound,
      title: 'Página no encontrada',
      backCb: route => history.back(),
    },
  ]

  const storesPromise = Promise.all([
    setupGroupsStore(),
    setupHomeworksStore(),
    setupHomeworkResourcesStore(),
  ])

  const route = router(routes)
  const title = writable($route.title)
  const extraFn = writable(null)
  $: $title = $route.title

  // set document title
  const setTitle = () => {
    document.title = $title + ' | Manejador de Tareas'
  }
  const onLoad = () => {
    setTitle()
    title.subscribe(setTitle)
  }

  // three dots
  $: $extraFn = $route && null

  // updates
  $: $updateAvailable &&
    setToast(
      '¡Hay una actualización disponible!',
      [
        {
          text: 'Actualizar',
          fn: () => window.__registration.waiting.postMessage('skipWaiting'),
        },
      ],
      9999999,
    )

  // automatically ensure offline
  setInterval(ensureOffline, 30 * 1000)
</script>

{#if false}
  <svg />
  <!-- for purgeCSS -->
{/if}

<svelte:window on:load={onLoad} />
<div
  class="flex flex-col min-h-screen h-auto antialiased text-gray-900 bg-gray-100
  dark:text-gray-200 dark:bg-gray-900"
>
  {#await storesPromise}
    <LoadingBox />
  {:then}
    <div class="shadow sticky top-0 bg-white dark:bg-gray-800 z-20">
      {#if $offline}
        <div class="w-full p-2 bg-black text-white text-center">
          Sin internet
        </div>
      {/if}
      <nav class="p-1 h-12" role="navigation" aria-label="main navigation">
        <div class="max-w-xl m-auto h-full flex content-center">
          <button
            class="h-full float-left focus:outline-none focus:shadow-outline"
            aria-label={$route.backCb ? 'ir atrás' : 'pantalla principal'}
            on:click={() => $route.backCb && $route.backCb($route)}
          >
            {#if $route.backCb}
              <ArrowBack props={{ class: 'h-full', 'aria-hidden': true }} />
            {:else}
              <HomeOutline
                props={{ class: 'h-full p-1', 'aria-hidden': true }}
              />
            {/if}
          </button>
          <span class="text-2xl font-bold m-auto ml-2 truncate">{$title}</span>
          {#if $extraFn}
            <button
              class="h-full float-right focus:outline-none focus:shadow-outline"
              aria-label="más acciones"
              on:click={$extraFn}
            >
              <MoreVertical
                props={{ class: 'h-full p-1', 'aria-hidden': true }}
              />
            </button>
          {/if}
        </div>
      </nav>
    </div>
    <main class="router-view flex-grow">
      <RouterView route={$route} {title} {extraFn} />
    </main>
    <footer class="w-full">
      <div class="mx-w-lg mx-4 my-8">
        <p class="text-center">
          <a
            href="//tareas.nulo.in"
            class="link inline-flex"
            target="_blank"
            rel="noopener"
          >
            Acerca del Manejador de Tareas
            <ExternalLink props={{ class: 'h-6 ml-2 inline-block' }} />
          </a>
        </p>
      </div>
    </footer>
    <ToastView />
  {:catch error}
    <div class="text-red-700 mx-auto my-8 text-xl text-center">
      Algo salió mal.
      <pre>{error}</pre>
    </div>
  {/await}
</div>
